$fn = 50;

module base(distance) {
  union() {
    translate([0,distance,-1.5]) cube([12,11,3],center=true);
    translate([0,distance+6.5,-1.5]) cube([4,28,3],center=true);
  }
}

module ledhold(distance) {
  xoffset = 0;
    union()
    {
      translate([xoffset,distance-4,4])
        rotate([90,0,0])
        linear_extrude(height = 8, center = true, convexity = 10, twist = 0)
        polygon([[-4,-2],[-4,2],[-2,4],[2,4],[4,2],[4,-2],[2,-4],[-2,-4] ],
        [[0,1,2,3,4,5,6,7]]);
      translate([xoffset,distance-3,0]) cube([6.5,6,3],center=true);
      translate([xoffset-4.5,distance-0.5,-1]) cube([3,11,2],center=true);
      translate([xoffset+4.5,distance-0.5,-1]) cube([3,11,2],center=true);
    }
}

difference()
{
  union()
  {
    for (distance = [45, 17, -11, -39]) {
      base(distance);
      ledhold(distance+0.5);
    }
  }

  for (distance = [45, 17, -11, -39]) {
    translate([0,distance+0.55,4]) rotate([90,0,0]) cylinder(r=2.85,h=8.1);
    translate([-4.25,distance+6.5,0.1]) rotate([90,0,0]) cylinder(r=1,h=13);
    translate([4.25,distance+6.5,0.1]) rotate([90,0,0]) cylinder(r=1,h=13);
  }
  //chop overhang
  translate([0,55.5,0]) cube([13,20,8],center=true);

}
